/*
 * vmremul.js : JavaScript/HTML emulation of the VM-R Conventional Machine
 *
 * version 1.2, May 23, 2002
 *
 * Copyright C 2000-2002 by Giovanni Chiola <chiola@disi.unige.it>
 *                     DISI, Universita' di Genova
 *                     via Dodecaneso 35, 16146 Genova, Italy.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * See URL http://www.gnu.org/copyleft/gpl.html for details.
 */

mydisplRAM = 200
myRAM = new Array

myReg = new Array
myRCoding = new Array

myIR = 0
myImmreg = 0x8000
myOmmreg = 0x8000
myEmulState = 0
myCurrInstr = 0
myCurrOp1 = 0
myCurrOp2 = 0
myCurrOp3 = 0
myCurrCond = 0
myClock = 0
mySTEP = 0
mySchedOut = 0

myramCoding = 3
myOpcodeType = 0
mystckCoding = 3

myIRCoding = 3
myIdevCoding = 3
myOdevCoding = 3
myOutDelay = 3

myFileCoding = 16

function resetram() {
  var i = 0

  for (i=0 ; i < 32768 ; i++)
    myRAM[i] = 0
}

function setfilecoding() {
  if ( parent.controlFrame.document.controlForm.filecoding.options[0].selected ) {
      myFileCoding = 10
  } else
  if ( parent.controlFrame.document.controlForm.filecoding.options[1].selected ) {
      myFileCoding = 2
  } else
  if ( parent.controlFrame.document.controlForm.filecoding.options[2].selected ) {
      myFileCoding = 8
  } else
  if ( parent.controlFrame.document.controlForm.filecoding.options[3].selected )
      myFileCoding = 16
}

function setramcoding() {
  var i = 0
  for ( i = 0 ; i < 5 ; i++ ) {
    if ( parent.controlFrame.document.controlForm.ramcoding.options[i].selected ) {
        myramCoding = i
        reprintram()
        break
      }
  }
}

function setopcodetype() {
  var i = 0
  for ( i = 0 ; i < 2 ; i++ ) {
    if ( parent.controlFrame.document.controlForm.opcodetype.options[i].selected ) {
        myOpcodeType = i
        parent.controlFrame.document.controlForm.curr_instr.value = printinstr(myCurrInstr,myCurrOp1,myCurrOp2,myCurrOp3)
        break
      }
  }
}

function setstckcoding() {
  var i = 0
  for ( i = 0 ; i < 5 ; i++ ) {
    if ( parent.controlFrame.document.controlForm.stckcoding.options[i].selected ) {
        mystckCoding = i
        reprintstck()
        break
      }
  }
}

function setRegCoding() {
  var i = 0
  var j = 0

  j = myRCoding[1]
  if ( ! (parent.cpuFrame.document.cpuForm.R01coding.options[j].selected) )
    for ( i = 0 ; i < 5 ; i++ )
      if ( parent.cpuFrame.document.cpuForm.R01coding.options[i].selected ) {
        myRCoding[1] = i
        reprintReg(1)
        return
       }
  j = myRCoding[2]
  if ( ! (parent.cpuFrame.document.cpuForm.R02coding.options[j].selected) )
    for ( i = 0 ; i < 5 ; i++ )
      if ( parent.cpuFrame.document.cpuForm.R02coding.options[i].selected ) {
        myRCoding[2] = i
        reprintReg(2)
        return
       }
  j = myRCoding[3]
  if ( ! (parent.cpuFrame.document.cpuForm.R03coding.options[j].selected) )
    for ( i = 0 ; i < 5 ; i++ )
      if ( parent.cpuFrame.document.cpuForm.R03coding.options[i].selected ) {
        myRCoding[3] = i
        reprintReg(3)
        return
       }
  j = myRCoding[4]
  if ( ! (parent.cpuFrame.document.cpuForm.PCcoding.options[j].selected) )
    for ( i = 0 ; i < 5 ; i++ )
      if ( parent.cpuFrame.document.cpuForm.PCcoding.options[i].selected ) {
        myRCoding[4] = i
        reprintReg(4)
        return
       }
  j = myRCoding[5]
  if ( ! (parent.cpuFrame.document.cpuForm.SPcoding.options[j].selected) )
    for ( i = 0 ; i < 5 ; i++ )
      if ( parent.cpuFrame.document.cpuForm.SPcoding.options[i].selected ) {
        myRCoding[5] = i
        reprintReg(5)
        return
       }
  j = myRCoding[6]
  if ( ! (parent.cpuFrame.document.cpuForm.FPcoding.options[j].selected) )
    for ( i = 0 ; i < 5 ; i++ )
      if ( parent.cpuFrame.document.cpuForm.FPcoding.options[i].selected ) {
        myRCoding[6] = i
        reprintReg(6)
        return
       }
  j = myRCoding[7]
  if ( ! (parent.cpuFrame.document.cpuForm.R07coding.options[j].selected) )
    for ( i = 0 ; i < 5 ; i++ )
      if ( parent.cpuFrame.document.cpuForm.R07coding.options[i].selected ) {
        myRCoding[7] = i
        reprintReg(7)
        return
       }
  j = myRCoding[8]
  if ( ! (parent.cpuFrame.document.cpuForm.R08coding.options[j].selected) )
    for ( i = 0 ; i < 5 ; i++ )
      if ( parent.cpuFrame.document.cpuForm.R08coding.options[i].selected ) {
        myRCoding[8] = i
        reprintReg(8)
        return
       }
  j = myRCoding[9]
  if ( ! (parent.cpuFrame.document.cpuForm.R09coding.options[j].selected) )
    for ( i = 0 ; i < 5 ; i++ )
      if ( parent.cpuFrame.document.cpuForm.R09coding.options[i].selected ) {
        myRCoding[9] = i
        reprintReg(9)
        return
       }
  j = myRCoding[10]
  if ( ! (parent.cpuFrame.document.cpuForm.R10coding.options[j].selected) )
    for ( i = 0 ; i < 5 ; i++ )
      if ( parent.cpuFrame.document.cpuForm.R10coding.options[i].selected ) {
        myRCoding[10] = i
        reprintReg(10)
        return
       }
  j = myRCoding[11]
  if ( ! (parent.cpuFrame.document.cpuForm.R11coding.options[j].selected) )
    for ( i = 0 ; i < 5 ; i++ )
      if ( parent.cpuFrame.document.cpuForm.R11coding.options[i].selected ) {
        myRCoding[11] = i
        reprintReg(11)
        return
       }
  j = myRCoding[12]
  if ( ! (parent.cpuFrame.document.cpuForm.R12coding.options[j].selected) )
    for ( i = 0 ; i < 5 ; i++ )
      if ( parent.cpuFrame.document.cpuForm.R12coding.options[i].selected ) {
        myRCoding[12] = i
        reprintReg(12)
        return
       }
  j = myRCoding[13]
  if ( ! (parent.cpuFrame.document.cpuForm.R13coding.options[j].selected) )
    for ( i = 0 ; i < 5 ; i++ )
      if ( parent.cpuFrame.document.cpuForm.R13coding.options[i].selected ) {
        myRCoding[13] = i
        reprintReg(13)
        return
       }
  j = myRCoding[14]
  if ( ! (parent.cpuFrame.document.cpuForm.R14coding.options[j].selected) )
    for ( i = 0 ; i < 5 ; i++ )
      if ( parent.cpuFrame.document.cpuForm.R14coding.options[i].selected ) {
        myRCoding[14] = i
        reprintReg(14)
        return
       }
  j = myRCoding[15]
  if ( ! (parent.cpuFrame.document.cpuForm.R15coding.options[j].selected) )
    for ( i = 0 ; i < 5 ; i++ )
      if ( parent.cpuFrame.document.cpuForm.R15coding.options[i].selected ) {
        myRCoding[15] = i
        reprintReg(15)
        return
       }
}

function setIdevcoding() {
  var i = 0
  for ( i = 0 ; i < 4 ; i++ ) {
    if ( parent.ioFrame.document.ioForm.Idevcoding.options[i].selected ) {
        myIdevCoding = i
        reprintIdev()
        break
      }
  }
}

function setOdevcoding() {
  var i = 0
  for ( i = 0 ; i < 4 ; i++ ) {
    if ( parent.ioFrame.document.ioForm.Odevcoding.options[i].selected ) {
        myOdevCoding = i
        reprintOdev()
        break
      }
  }
}

function printnumb(myCoding,noBits,i) {
  var j = 0
  var k = 0
  var l = 0
  var mask = 32768
  var str = ""

  if ( myCoding == 0 ) {
    if ( (i < 10) && (noBits > 12) )
      return("U 0000"+i)
    else if ( (i < 10) || ((i < 100) && (noBits > 12)) )
      return("U 000"+i)
    else if ( (i < 100) || ((i < 1000) && (noBits > 12)) )
      return("U 00"+i)
    else if ( (i < 1000) || ((i < 10000) && (noBits > 12)) )
      return("U 0"+i)
    else
      return("U "+i)
  } else if ( myCoding == 1 ) {
    mask = 1 << (noBits-1)
    str = "B"
    for (j=noBits ; j > 0 ; j--) {
        if ( i & mask )
          str += "1"
        else
          str += "0"
        mask >>= 1
      }
    return(str)
  } else if ( myCoding == 2 ) {
    str = ""
    mask = 7
    l = i
    for (j=(noBits+2)/3 ; j >= 1 ; j--) {
        k = l & mask;
        if ( k < 4 ) {
          if ( k < 2 ) {
            if ( k < 1 )
              str = "0"+str
            else
              str = "1"+str
          } else {
            if ( k < 3 )
              str = "2"+str
            else
              str = "3"+str
          }
        } else {
          if ( k < 6 ) {
            if ( k < 5 )
              str = "4"+str
            else
              str = "5"+str
          } else {
            if ( k < 7 )
              str = "6"+str
            else
              str = "7"+str
          }
        }
        l = l / 8
      }
    return("O "+str)
  } else if ( myCoding == 3 ) {
    str = ""
    mask = 15
    l = i
    for (j=(noBits+3), j >>= 2 ; j > 0 ; j--) {
        k = l & mask;
        if ( k < 8 ) {
          if ( k < 4 ) {
            if ( k < 2 ) {
              if ( k < 1 )
                str = "0"+str
              else
                str = "1"+str
            } else {
              if ( k < 3 )
                str = "2"+str
              else
                str = "3"+str
            }
          } else {
            if ( k < 6 ) {
              if ( k < 5 )
                str = "4"+str
              else
                str = "5"+str
            } else {
              if ( k < 7 )
                str = "6"+str
              else
                str = "7"+str
            }
          }
        } else {
          if ( k < 12 ) {
            if ( k < 10 ) {
              if ( k < 9 )
                str = "8"+str
              else
                str = "9"+str
            } else {
              if ( k < 11 )
                str = "A"+str
              else
                str = "B"+str
            }
          } else {
            if ( k < 14 ) {
              if ( k < 13 )
                str = "C"+str
              else
                str = "D"+str
            } else {
              if ( k < 15 )
                str = "E"+str
              else
                str = "F"+str
            }
          }
        }
        l = l / 16
      }
    return("H "+str)
  } else if ( myCoding == 4 ) {
    str = "D "
    mask = 1<<(noBits -1)
    if ( i & mask ) {
      str += "-"
      i ^= 0xFFF
      if ( noBits > 12 )
        i ^= 0xF000
      i += 1
      i &= 0xFFFF
      if ( noBits == 12 )
        i &= 0xFFF
    }
    return(str+i)
  }
}

function printcell(doc,myCod,i) {
 var myzeros = ""
 if ( i < 10000 ) {
   if ( i < 1000 ) {
     if ( i < 10 )
      myzeros = "0000"
     else if ( i < 100 )
      myzeros = "000"
     else
      myzeros = "00"
    }
   else
    myzeros = "0"
  }
  doc.write("<TR><TD><A NAME='addr"+i+"'>"+myzeros+i+
    "</A><TD>:<TD><INPUT type='text' readonly value='"+
    printnumb(myCod,16,myRAM[i-32768])+"' size='17' name='txt" + i + "'>")
}


function printregister(doc,myname,i) {
  doc.write("<INPUT type='text' name='"+myname+"' size='17' value='"+printnumb(myRCoding[i],16,myReg[i])+"' readonly>")
}

function reprintram() {
  var i = 0
  for ( i = 0 ; i < mydisplRAM ; i++ )

    parent.programFrame.document.programramForm.elements[i].value = printnumb(myramCoding,16,myRAM[i])
}

function reprintstck() {
  var i = 0
  var j = 32768-mydisplRAM
  for ( i = 0 ; i < mydisplRAM ; i++, j++ )
    parent.stackFrame.document.stackramForm.elements[i].value = printnumb(mystckCoding,16,myRAM[j])
}

function reprintReg( i ) {
 switch ( i ) {
  case 1:
    parent.cpuFrame.document.cpuForm.reg01.value = printnumb(myRCoding[1],16,myReg[1])
   break
  case 2:
    parent.cpuFrame.document.cpuForm.reg02.value = printnumb(myRCoding[2],16,myReg[2])
   break
  case 3:
    parent.cpuFrame.document.cpuForm.reg03.value = printnumb(myRCoding[3],16,myReg[3])
   break
  case 4:
    parent.cpuFrame.document.cpuForm.regPC.value = printnumb(myRCoding[4],16,myReg[4])
   break
  case 5:
    parent.cpuFrame.document.cpuForm.regSP.value = printnumb(myRCoding[5],16,myReg[5])
   break
  case 6:
    parent.cpuFrame.document.cpuForm.regFP.value = printnumb(myRCoding[6],16,myReg[6])
   break
  case 7:
    parent.cpuFrame.document.cpuForm.reg07.value = printnumb(myRCoding[7],16,myReg[7])
   break
  case 8:
    parent.cpuFrame.document.cpuForm.reg08.value = printnumb(myRCoding[8],16,myReg[8])
   break
  case 9:
    parent.cpuFrame.document.cpuForm.reg09.value = printnumb(myRCoding[9],16,myReg[9])
   break
  case 10:
    parent.cpuFrame.document.cpuForm.reg10.value = printnumb(myRCoding[10],16,myReg[10])
   break
  case 11:
    parent.cpuFrame.document.cpuForm.reg11.value = printnumb(myRCoding[11],16,myReg[11])
   break
  case 12:
    parent.cpuFrame.document.cpuForm.reg12.value = printnumb(myRCoding[12],16,myReg[12])
   break
  case 13:
    parent.cpuFrame.document.cpuForm.reg13.value = printnumb(myRCoding[13],16,myReg[13])
   break
  case 14:
    parent.cpuFrame.document.cpuForm.reg14.value = printnumb(myRCoding[14],16,myReg[14])
   break
  case 15:
    parent.cpuFrame.document.cpuForm.reg15.value = printnumb(myRCoding[15],16,myReg[15])
   break
 }
}

function reprintIdev() {
  parent.ioFrame.document.ioForm.RAM16384.value = printnumb(myIdevCoding,16,myImmreg)
}

function reprintOdev() {
  parent.ioFrame.document.ioForm.RAM16385.value = printnumb(myOdevCoding,16,myOmmreg)
}

function generatecodoptions(doc,no_opts) {
  doc.write("<OPTION>u d</OPTION><OPTION>bin</OPTION>"+
            "<OPTION>oct</OPTION><OPTION selected>hex</OPTION>")
  if ( no_opts > 4 )
    doc.write("<OPTION>s d</OPTION>")
  doc.write("</SELECT>")
}

function shft_rota_const(val) {
  var vv = val & 0x7
  var str = "+"
  if ( val & 0x8 )
    str = "-"
  vv++
  return(str+vv)
}

function signed_short(sign_bit,val) {
  var sss = 1<<sign_bit
  var mask = sss-1
  var str = " "
  if ( val & sss ) {
    str += "-"
    val ^= mask
    val++
    val &= mask
  }
  return(str+val)
}

function printinstr(CurInstr,CurOp1,CurOp2,CurOp3) {
  var aux = 0
  if ( CurInstr == 0 && CurOp3 == 0 && myOpcodeType > 0 )
    return("MOV2 R"+CurOp1+", R"+CurOp2)
  if ( CurInstr == 0 )
    return("ADD3 R"+CurOp1+", R"+CurOp2+", R"+CurOp3)
  if ( CurInstr == 1 )
    return("AND3 R"+CurOp1+", R"+CurOp2+", R"+CurOp3)
  if ( CurInstr == 2 )
    return("LOR3 R"+CurOp1+", R"+CurOp2+", R"+CurOp3)
  if ( CurInstr == 3 )
    return("LOAD R"+CurOp1+", R"+CurOp2+", R"+CurOp3)
  if ( CurInstr == 4 && CurOp1 == 0 && myOpcodeType > 0 )
    return("SCMP R"+CurOp2+", R"+CurOp3)
  if ( CurInstr == 4 )
    return("SUB3 R"+CurOp1+", R"+CurOp2+", R"+CurOp3)
  if ( CurInstr == 5 && CurOp2 == CurOp3 && myOpcodeType > 0 )
    return("NOT2 R"+CurOp1+", R"+CurOp2)
  if ( CurInstr == 5 )
    return("NAND R"+CurOp1+", R"+CurOp2+", R"+CurOp3)
  if ( CurInstr == 6 && CurOp1 == 7 && CurOp2 == 4 && myOpcodeType > 0 )
    return("CALL R"+CurOp3)
  if ( CurInstr == 6 && CurOp1 == 0 && CurOp2 == 4 && CurOp3 == 7 && myOpcodeType > 0 )
    return("RETN")
  if ( CurInstr == 6 )
    return("MOVR R"+CurOp1+", R"+CurOp2+", R"+CurOp3)
  if ( CurInstr == 7 )
    return("STOR R"+CurOp1+", R"+CurOp2+", R"+CurOp3)
  if ( CurInstr == 8 )
    return("ROTA R"+CurOp1+", R"+CurOp2+","+shft_rota_const(CurOp3))
  if ( CurInstr == 9 ) {
    aux = CurOp3+1
    return("PUSH R"+CurOp1+", R"+CurOp2+", "+aux)
  }
  if ( CurInstr == 10 )
    return("SHFT R"+CurOp1+", R"+CurOp2+","+shft_rota_const(CurOp3))
  if ( CurInstr == 11 && CurOp2 == 4 && CurOp3 == 0 && myOpcodeType > 0 )
    return("LDIW R"+CurOp1+", "+printnumb(3,16,myRAM[myReg[4]-32768]))
  if ( CurInstr == 11 ) {
    aux = CurOp3+1
    return("POPR R"+CurOp1+", R"+CurOp2+", "+aux)
  }
  if ( CurInstr == 12 )
    return("ADD1 R"+CurOp1+signed_short(7,CurOp2))
  if ( CurInstr == 13 )
    return("AND1 R"+CurOp1+", "+CurOp2)
  if ( CurInstr == 14 )
    return("LDIB R"+CurOp1+signed_short(7,CurOp2))
  if ( CurInstr == 15 ) {
    if ( CurOp1 == 0 && CurOp2 == 0x1FF && myOpcodeType > 0 )
      return("HALT")
    if ( CurOp1 == 0 )
      return("CJMP ALWAYS "+signed_short(8,CurOp2))
    if ( CurOp1 == 1 )
      return("CJMP =0 "+signed_short(8,CurOp2))
    if ( CurOp1 == 2 )
      return("CJMP >0 "+signed_short(8,CurOp2))
    if ( CurOp1 == 3 )
      return("CJMP >=0 "+signed_short(8,CurOp2))
    if ( CurOp1 == 4 )
      return("CJMP OVRFLW "+signed_short(8,CurOp2))
    if ( CurOp1 == 5 )
      return("CJMP <>0 "+signed_short(8,CurOp2))
    if ( CurOp1 == 6 )
      return("CJMP <=0 "+signed_short(8,CurOp2))
    if ( CurOp1 == 7 )
      return("CJMP <0 "+signed_short(8,CurOp2))
   }
  return("????")
}

function emulate_mem_write(Addr,Val) {
  var aux = 0
  if ( Addr > 32767 ) {
    Addr -= 32768
    myRAM[Addr] = Val 
    if ( Addr < mydisplRAM )
      parent.programFrame.document.programramForm.elements[Addr].value = printnumb(myramCoding,16,Val)
    aux = 32768-mydisplRAM
    if ( Addr >= aux )
      parent.stackFrame.document.stackramForm.elements[Addr-aux].value = printnumb(mystckCoding,16,Val)
  } else {
    if ( Addr == 16385 ) {
      myOmmreg = Val
      parent.ioFrame.document.ioForm.RAM16385.value = printnumb(myOdevCoding,16,myOmmreg)
      if ( ! (Val & 0x8000) )
        mySchedOut = myClock+myOutDelay+1
    }
  }
}

function emulate_mem_read(Addr) {
  var aux = 0
  if ( Addr > 32767 )
    aux = myRAM[Addr-32768]
  else if ( Addr == 16384 ) {
    aux = myImmreg
    myImmreg |= 0x8000
    parent.ioFrame.document.ioForm.RAM16384.value = printnumb(myIdevCoding,16,myImmreg)
    parent.ioFrame.document.ioForm.input_dev.value = ""
  } else if ( Addr == 16385 )
    aux = myOmmreg
  return(aux)
}

function change_PC() {
  var aux = myReg[4]
  if ( aux >= 1 )
    aux--
  parent.cpuFrame.document.cpuForm.regPC.value = printnumb(myRCoding[4],16,myReg[4])
  parent.programFrame.location = "ram_prgm.htm#addr"+aux
}

function change_SP() {
  parent.cpuFrame.document.cpuForm.regSP.value = printnumb(myRCoding[5],16,myReg[5])
  parent.stackFrame.location = "ram_stck.htm#addr"+myReg[5]
}

function emulate_fetch() {
  if ( (myEmulState != 1) ) {
    myEmulState = 1
    parent.controlFrame.document.controlForm.fetchstep.disabled = true
    parent.controlFrame.document.controlForm.execstep.disabled = false
    myIR = emulate_mem_read(myReg[4])
    myReg[4]++
  }
  change_PC()
  myCurrInstr = myIR >> 12
  if ( myCurrInstr < 12 ) {
    myCurrOp1 = myIR >> 8
    myCurrOp1 &= 0xF
    myCurrOp2 = myIR >> 4
    myCurrOp2 &= 0xF
    myCurrOp3 = myIR & 0xF
  } else if ( myCurrInstr < 15 ) {
    myCurrOp1 = myIR >> 8
    myCurrOp1 &= 0xF
    myCurrOp2 = myIR & 0xFF
    myCurrOp3 = 0
  } else {
    myCurrOp1 = myIR >> 9
    myCurrOp1 &= 0x7
    myCurrOp2 = myIR & 0x1FF
    myCurrOp3 = 0
  }
  parent.controlFrame.document.controlForm.curr_instr.value = printinstr(myCurrInstr,myCurrOp1,myCurrOp2,myCurrOp3)
}

function emulate_exec() {
  var scond = ""
  var i = 0
  var aux = 0
  var aux2 = 0
  var aux3 = 0
  var pos2 = true
  var pos3 = true
  if ( (myEmulState == 1) ) {
    myEmulState = 2
    parent.controlFrame.document.controlForm.fetchstep.disabled = false
    parent.controlFrame.document.controlForm.execstep.disabled = true
    switch (myCurrInstr) {
    case  0: /*** ADD3 ***/
       if ( myCurrOp3 > 0 ) {
         aux = myReg[myCurrOp3]
         if ( aux & 0x8000 )
           pos3 = false;
       }
       if ( myCurrOp2 > 0 ) {
         if ( myReg[myCurrOp2] & 0x8000 )
           pos2 = false;
         aux += myReg[myCurrOp2]
       }
       myCurrCond = aux & 0xFFFF
       if ( pos2 && pos3 && (aux > 0x7FFF) )
           myCurrCond |= 0x10000
       else if ( (!pos2) && (!pos3) && (myCurrCond < 0x8000) )
           myCurrCond |= 0x10000
       if ( myCurrOp1 > 0 ) {
         myReg[myCurrOp1] = 0xFFFF & aux
         if ( myCurrOp1 == 4 )
           change_PC()
         else if ( myCurrOp1 == 5 )
           change_SP()
         else
           reprintReg(myCurrOp1)
       }
     break
    case  1: /*** AND3 ***/
       if ( myCurrOp3 > 0 ) {
         aux = myReg[myCurrOp3]
       }
       if ( myCurrOp2 > 0 ) {
         aux &= myReg[myCurrOp2]
       }
       myCurrCond = aux
       if ( myCurrOp1 > 0 ) {
         myReg[myCurrOp1] = aux
         if ( myCurrOp1 == 4 )
           change_PC()
         else if ( myCurrOp1 == 5 )
           change_SP()
         else
           reprintReg(myCurrOp1)
       }
     break
    case  2: /*** LOR3 ***/
       if ( myCurrOp3 > 0 ) {
         aux = myReg[myCurrOp3]
       }
       if ( myCurrOp2 > 0 ) {
         aux |= myReg[myCurrOp2]
       }
       myCurrCond = aux
       if ( myCurrOp1 > 0 ) {
         myReg[myCurrOp1] = aux
         if ( myCurrOp1 == 4 )
           change_PC()
         else if ( myCurrOp1 == 5 )
           change_SP()
         else
           reprintReg(myCurrOp1)
       }
     break
    case  3: /*** LOAD ***/
       if ( myCurrOp3 > 0 ) {
         aux = myReg[myCurrOp3]
       }
       if ( myCurrOp2 > 0 ) {
         aux += myReg[myCurrOp2]
       }
       aux &= 0xFFFF
       myCurrCond = emulate_mem_read(aux)
       if ( myCurrOp1 > 0 ) {
         myReg[myCurrOp1] = myCurrCond
         if ( myCurrOp1 == 4 )
           change_PC()
         else if ( myCurrOp1 == 5 )
           change_SP()
         else
           reprintReg(myCurrOp1)
       }
     break
    case  4: /*** SUB3 ***/
       if ( myCurrOp3 > 0 ) {
         aux = myReg[myCurrOp3] ^ 0xFFFF
         aux++
         aux &= 0xFFFF
         if ( aux & 0x8000 )
           pos3 = false;
       }
       if ( myCurrOp2 > 0 ) {
         if ( myReg[myCurrOp2] & 0x8000 )
           pos2 = false;
         aux += myReg[myCurrOp2]
       }
       myCurrCond = aux & 0xFFFF
       if ( pos2 && pos3 && (aux > 0x7FFF) )
           myCurrCond |= 0x10000
       else if ( (!pos2) && (!pos3) && (myCurrCond < 0x8000) )
           myCurrCond |= 0x10000
       if ( myCurrOp1 > 0 ) {
         myReg[myCurrOp1] = 0xFFFF & aux
         if ( myCurrOp1 == 4 )
           change_PC()
         else if ( myCurrOp1 == 5 )
           change_SP()
         else
           reprintReg(myCurrOp1)
       }
     break
    case  5: /*** NAND ***/
       if ( myCurrOp3 > 0 ) {
         aux = myReg[myCurrOp3]
       }
       if ( myCurrOp2 > 0 ) {
         aux &= myReg[myCurrOp2]
       }
       aux ^= 0xFFFF
       myCurrCond = aux
       if ( myCurrOp1 > 0 ) {
         myReg[myCurrOp1] = aux
         if ( myCurrOp1 == 4 )
           change_PC()
         else if ( myCurrOp1 == 5 )
           change_SP()
         else
           reprintReg(myCurrOp1)
       }
     break
    case  6: /*** MOVR ***/
       if ( myCurrOp3 > 0 ) {
         aux2 = myReg[myCurrOp3]
       }
       if ( myCurrOp2 > 0 ) {
         aux = myReg[myCurrOp2]
         myReg[myCurrOp2] = aux2
         if ( myCurrOp2 == 4 )
           change_PC()
         else if ( myCurrOp2 == 5 )
           change_SP()
         else
           reprintReg(myCurrOp2)
       }
       if ( myCurrOp1 > 0 ) {
         myReg[myCurrOp1] = aux
         if ( myCurrOp1 == 4 )
           change_PC()
         else if ( myCurrOp1 == 5 )
           change_SP()
         else
           reprintReg(myCurrOp1)
       }
     break
    case  7: /*** STOR ***/
       if ( myCurrOp3 > 0 ) {
         aux = myReg[myCurrOp3]
       }
       if ( myCurrOp2 > 0 ) {
         aux += myReg[myCurrOp2]
       }
       aux &= 0xFFFF
       myCurrCond = 0
       if ( myCurrOp1 > 0 ) {
         myCurrCond = myReg[myCurrOp1]
       }
       emulate_mem_write(aux,myCurrCond)
     break
    case  8: /*** ROTA ***/
       if ( myCurrOp3 & 0x8 )
         pos2 = false
       aux2 = myCurrOp3 & 0x7
       aux2++
       if ( myCurrOp2 > 0 ) {
         aux = myReg[myCurrOp2]
         if ( pos2 ) {
           aux = (aux << aux2) | (aux >> (8 - aux2))
           aux &= 0xFFFF
         } else {
           aux = (aux >> aux2) | (aux << (8 - aux2))
           aux &= 0xFFFF
         }
       }
       myCurrCond = aux
       if ( myCurrOp1 > 0 ) {
         myReg[myCurrOp1] = aux
         if ( myCurrOp1 == 4 )
           change_PC()
         else if ( myCurrOp1 == 5 )
           change_SP()
         else
           reprintReg(myCurrOp1)
       }
     break
    case  9: /*** PUSH ***/
       aux = myCurrOp1 + myCurrOp3+1
       if ( myCurrOp2 > 0 ) {
         aux2 = myReg[myCurrOp2]
       }
       for ( i = 0 ; i <= myCurrOp3 ; i++ ) {
         aux2--
         aux2 &= 0xFFFF
         aux3 = 0
         aux--
         aux &= 0xF
         if ( aux > 0 )
           aux3 = myReg[aux]
         emulate_mem_write(aux2,aux3)
       }
       if ( myCurrOp2 > 0 ) {
         myReg[myCurrOp2] = aux2
         if ( myCurrOp2 == 4 )
           change_PC()
         else if ( myCurrOp2 == 5 )
           change_SP()
         else
           reprintReg(myCurrOp2)
       }
     break
    case 10: /*** SHFT ***/
       if ( myCurrOp3 & 0x8 )
         pos2 = false
       aux2 = myCurrOp3 & 0x7
       aux2++
       if ( myCurrOp2 > 0 ) {
         aux = myReg[myCurrOp2]
         if ( pos2 ) {
           aux = (aux << aux2)
           aux &= 0xFFFF
         } else {
           aux = (aux >> aux2)
         }
       }
       myCurrCond = aux
       if ( myCurrOp1 > 0 ) {
         myReg[myCurrOp1] = aux
         if ( myCurrOp1 == 4 )
           change_PC()
         else if ( myCurrOp1 == 5 )
           change_SP()
         else
           reprintReg(myCurrOp1)
       }
     break
    case 11: /*** POPR ***/
       aux = myCurrOp1 + myCurrOp3+1
       if ( myCurrOp2 > 0 ) {
         aux2 = myReg[myCurrOp2]
       }
       aux2 += myCurrOp3
       aux2 &= 0xFFFF
       for ( i = 0 ; i <= myCurrOp3 ; i++ ) {
         aux--
         aux &= 0xF
         if ( aux > 0 ) {
           if ( aux == myCurrOp2 )
             pos2 = false /* TAKE THE POPPED VALUE FOR THE STACK POINTER */
           aux3 = emulate_mem_read(aux2)
           myReg[aux] = aux3
           if ( aux == 4 )
             change_PC()
           else if ( aux == 5 )
             change_SP()
           else
             reprintReg(aux)
         }
         aux2--
         aux2 &= 0xFFFF
       }
       if ( (myCurrOp2 > 0) && pos2 ) {
         myReg[myCurrOp2] += i
         if ( myCurrOp2 == 4 )
           change_PC()
         else if ( myCurrOp2 == 5 )
           change_SP()
         else
           reprintReg(myCurrOp2)
       }
     break
    case 12: /*** ADD1 ***/
       aux = myCurrOp2
       if ( aux & 0x80 ) {
         aux |= 0xFF00
         pos3 = false
       }
       if ( myCurrOp1 > 0 ) {
         if ( myReg[myCurrOp1] & 0x8000 )
           pos2 = false
         aux += myReg[myCurrOp1]
         aux &= 0xFFFF
       }
       myCurrCond = aux
       if ( pos2 && pos3 && (aux > 0x7FFF) )
           myCurrCond |= 0x10000
       else if ( (!pos2) && (!pos3) && (aux < 0x8000) )
           myCurrCond |= 0x10000
       if ( myCurrOp1 > 0 ) {
         myReg[myCurrOp1] = aux
         if ( myCurrOp1 == 4 )
           change_PC()
         else if ( myCurrOp1 == 5 )
           change_SP()
         else
           reprintReg(myCurrOp1)
       }
     break
    case 13: /*** AND1 ***/
       myCurrCond = myCurrOp2
       if ( myCurrOp1 > 0 ) {
         myCurrCond &= myReg[myCurrOp1]
       }
       if ( myCurrOp1 > 0 ) {
         myReg[myCurrOp1] = myCurrCond
         if ( myCurrOp1 == 4 )
           change_PC()
         else if ( myCurrOp1 == 5 )
           change_SP()
         else
           reprintReg(myCurrOp1)
       }
     break
    case 14: /*** LDIB ***/
       if ( myCurrOp1 > 0 ) {
         aux = myCurrOp2
         if ( aux & 0x80 ) {
           aux |= 0xFF00
         }
         myReg[myCurrOp1] = aux
         if ( myCurrOp1 == 4 )
           change_PC()
         else if ( myCurrOp1 == 5 )
           change_SP()
         else
           reprintReg(myCurrOp1)
       }
     break
    case 15: /*** CJMP ***/
       if ( myCurrOp1 < 4 ) {
         if ( (myCurrOp1 == 1) && ((myCurrCond & 0xFFFF) != 0) )
           break
         if ( (myCurrOp1 == 2) && ((myCurrCond & 0x8000) || !(myCurrCond & 0x7FFF)) )
           break
         if ( (myCurrOp1 == 3) && (myCurrCond & 0x8000) )
           break
       } else {
         if ( (myCurrOp1 == 4) && (!(myCurrCond & 0x10000)) )
           break
         if ( (myCurrOp1 == 5) && ((myCurrCond & 0xFFFF) == 0) )
           break
         if ( (myCurrOp1 == 6) && (!(myCurrCond & 0x8000)) && ((myCurrCond & 0x7FFF) > 0) )
           break
         if ( (myCurrOp1 == 7) && (!(myCurrCond & 0x8000)) )
           break
       }
       aux = myCurrOp2
       if ( aux & 0x100 ) {
         aux |= 0xFF00
       }
       aux += myReg[4]
       aux &= 0xFFFF
       myReg[4] = aux
       change_PC()
     break
    default:
     break
    }
    if ( myCurrCond & 0x10000 )
      scond = "V"
     else
      scond = " "
    if ( myCurrCond & 0x8000 )
      scond = scond+"<"
    else if ( myCurrCond & 0x7FFF )
      scond = scond+">"
    else
      scond = scond+"="
    parent.controlFrame.document.controlForm.curcond.value = scond
    myClock++
    parent.controlFrame.document.controlForm.clock_count.value = ""+myClock
    if ( mySchedOut > 0 ) {
      if ( (mySchedOut <= myClock) )
        put_output()
    }
    parent.controlFrame.document.controlForm.curr_instr.value = ""
  }
}

function get_input() {
  var mystr = new String(parent.ioFrame.document.ioForm.input_dev.value)
  var aux = mystr.charCodeAt(0)
  if ( mystr.length > 0 ) {
    myImmreg = (aux & 0x7F)
    parent.ioFrame.document.ioForm.RAM16384.value = printnumb(myIdevCoding,16,myImmreg)
  }
}

function get_output_delay() {
  myOutDelay = parseInt(parent.ioFrame.document.ioForm.output_delay.value)
  if ( myOutDelay < 1 )
    myOutDelay = 1
}

function put_output() {
  var aux = myOmmreg & 0x7F
  myOmmreg |= 0x8000
  parent.ioFrame.document.ioForm.RAM16385.value = printnumb(myOdevCoding,16,myOmmreg)
  parent.ioFrame.document.ioForm.output_dev.value += String.fromCharCode(aux)
  mySchedOut = 0
}

function start_run() {
  mySTEP = parseInt(parent.controlFrame.document.controlForm.no_clock.value,10)
  while ( mySTEP > 0 ) {
    mySTEP--
    emulate_fetch()
    emulate_exec()
    if ( parent.controlFrame.document.controlForm.stoprun.checked )
      mySTEP = 0
  }
}

function stop_run() {
  mySTEP = 0
}

function refresh_all() {
  var i = 0
  reprintram()
  reprintstck()
  for ( i = 1 ; i < 4 ; i++ )
    reprintReg(i)
  change_PC()
  change_SP()
  for ( i = 6 ; i < 16 ; i++ )
    reprintReg(i)
  reprintIdev()
  reprintOdev()
}

function reset_VMR(ld) {
  var i = 0
  for ( i = 0 ; i < 16 ; i++ ) {
    myReg[i] = 0
   }
  myReg[4] = 32768
  myReg[5] = 65535
  myReg[6] = 65535
  resetram()
  myIR = 0
  myImmreg = 0x8000
  myOmmreg = 0x8000
  mySchedOut = 0
  myEmulState = 0
  myCurrInstr = 0
  myCurrOp = 0
  myClock = 0
  mySTEP = 0
  if ( ld ) {
    refresh_all()
    parent.ioFrame.document.ioForm.input_dev.value = ""
    parent.ioFrame.document.ioForm.output_dev.value = ""
    parent.controlFrame.document.controlForm.clock_count.value = "0"
    parent.controlFrame.document.controlForm.curr_instr.value = ""
    parent.controlFrame.document.controlForm.curcond.value = " ="
  }
}

function load_file() {
  var filn = parent.controlFrame.document.controlForm.VMR_program_file.value
  var myarr = parent.controlFrame.document.applets[0].RamLines(filn)
  var i = 0
  var mystr = ""
  var j = 0
  reset_VMR(true)
  for ( mystr = myarr[0] ; mystr != null ; i++, mystr = myarr[i] ) {
    j = parseInt(mystr,myFileCoding)
    if ( j == NaN )
      break
    j &= 0xFFFF
    myRAM[i] = j
  }
  refresh_all()
}


function resetall() {
  var i = 0
  for ( i = 0 ; i < 16 ; i++ ) {
    myRCoding[i] = 3
   }
  reset_VMR(false)
}

resetall()

